// Copyright (C) 1990 by Glenn Gribble; all rights are reserved.
// This program may be used for any purposes including inclusion in
// for profit programs.  If the source is copied, the copyright notice
// must be included.  Please send bug fixes/reports to glenn@synaptics.com
// This program is distributed without any warranty.

// -*- C++ -*-
// %W% %G%

#ifndef LOADER_H
#define LOADER_H

#ifndef bool
#   define bool unsigned
#endif	bool

#ifndef TRUE
#   define TRUE 1
#endif

#ifndef FALSE
#   define FALSE 0
#endif

extern void error(const char *fmt ...);
extern void warn(const char *fmt ...);
extern void info(const char *fmt ...);

extern int d_all;
extern int d_relocation;
extern int d_execs;
extern int d_ctors;
extern int d_relocation;
extern int d_symbols;

extern void setArg0(const char *);		// Call with argv[0]
extern bool loadFile(const char *fileName);	// Loads an object file
extern long value(const char *sym, int bad=-1);	// Returns symbol value

#endif  LOADER_H
